   member()
   include('mysql.inc')
   map
       module('sol.cpp')
           sol(ulong,ulong,*cstring),ulong,RAW,NAME('_sol');
       .
       include('mysqlf.inc')
   end

include('CWSYNCHC.INC'),ONCE   !include CriticalSection

MysqlLock CriticalSection

mys    cstring(1024),auto
buff   cstring(65535),auto
buff1  cstring(65535),auto
ssrt   cstring(1024),auto

qff    queue,pre(qff)
ptr        &string
name       cstring(33)
       .

mysqlclassType.initall procedure(*cstring host, *cstring user, *cstring passwd, *cstring db, ulong port)
   code
   self.pmysql=mysql_init(0)
   if not self.pmysql; self.mess__(1); return(1) .
   jj#=mysql_options(self.pmysql,8,0)
   jj#=mysql_real_connect(self.pmysql,host,user,passwd,db,port,0,0)
   if not jj#;
       self.mess__(2)
       mysql_close(self.pmysql)
       return(2)
   .
   return(0)

mysqlclassType.init procedure(pmysql)
   code
   self.pmysql=pmysql
   self.qqq  &= new mysqlqueue
   self.qsrt &= new mysqlqueue
   clear(self.pres)
   clear(self.filter)
   clear(self.limit)
   clear(self.fillcount)
   return(0)

mysqlclassType.killall procedure
   code
   mysql_close(self.pmysql)

mysqlclassType.kill procedure
   code
   free(self.qqq)
   dispose(self.qqq)
   free(qff)
   free(self.qsrt)
   dispose(self.qsrt)
   if self.pres
       mysql_free_result(self.pres)
       clear(self.pres)
   .

mysqlclassType.tab_init procedure(string stab,string sprimary,*string primaryptr,<byte desc>)
   code
   self.tab=clip(stab)
   self.primarykey=clip(sprimary)
   self.primaryptr &= primaryptr
   self.desc=0
   if ~omitted(5); self.desc=desc; .

mysqlclassType.sortkey  procedure(string sortkey)
   code
   free(self.qsrt)
   if not omitted(2)
       mys=clip(sortkey)
       if self.get::qff(mys);
           loop i#=1 to records(qff)
               get(qff,i#)
!              if qff:name=self.primarykey; cycle .
               self.qsrt :=: qff
               add(self.qsrt)
           .
           free(qff)
   .   .

mysqlclassType.addfield procedure(*string fieldptr,string name)
   code
   clear(self.qqq)
   self.qqq.ptr &= fieldptr
   self.qqq.name=clip(name)
   add(self.qqq)

mysqlclasstype.mess__  procedure(act)
s1     cstring(100),auto
s2     cstring(1024),auto

QuickWindow WINDOW('   '),AT(,,410,110),FONT('MS Sans Serif',8,,,CHARSET:CYRILLIC), |
         CENTER,IMM,SYSTEM,GRAY,DOUBLE,MASK,MODAL
       SHEET,AT(3,4,403,84),USE(?CurrentTab),WIZARD,SPREAD
         TAB,USE(?tab1)
           STRING(@s100),AT(9,10,391,10),USE(s1),TRN,CENTER
           TEXT,AT(8,23,393,62),USE(s2),VSCROLL,COLOR(COLOR:Silver),READONLY
         END
       END
       BUTTON('Ok'),AT(182,93,45,14),USE(?ok)
     END

   code
   if self.pmysql
       s1='  '& mysql_errno(self.pmysql) &' ('&act&')'
       s2=mysql_error(self.pmysql)
   else
       s1=' ('&act&')'
   .
   setcursor()
   open(quickwindow); display(); select(?ok)
   accept
       case event()
       of event:accepted
           post(event:closewindow)
       .
   .
   close(quickwindow)

mysqlclassType.prepare procedure()
   code
   if self.ping()
       return(1)
   .
   clear(self.kol_all)
   MysqlLock.Wait()
   if self.fillcount
       if self.zapros2
!        message(self.zapros2)
           kk#=mysql_real_query(self.pmysql, self.zapros2, len(self.zapros))
           if not kk#
               self.pres=mysql_store_result(self.pmysql)
               if ~self.pres; MysqlLock.Release(); return(2) .
               self.prow=mysql_fetch_row(self.pres)
               if ~self.prow; mysql_free_result(self.pres); MysqlLock.Release(); return(2) .
               j#=sol(1,self.prow,buff)
               self.kol_all=buff
               mysql_free_result(self.pres)
               clear(self.pres)
       .   .
   .
!        message(self.zapros)
   kk#=mysql_real_query(self.pmysql, self.zapros, len(self.zapros))
   if kk#; self.mess__(3); MysqlLock.Release(); return(3) .

   self.pres=mysql_store_result(self.pmysql)
   if not self.pres; self.mess__(4); MysqlLock.Release(); return(4) .

   self.kolrec=mysql_affected_rows(self.pmysql)
   MysqlLock.Release();
   self.kolfields=mysql_num_fields(self.pres)
   return(0)

mysqlclassType.free_rez    procedure
   code
   free(qff)
   if self.pres
       mysql_free_result(self.pres)
       clear(self.pres)
   .

mysqlclassType.fillnext    procedure
ret:val    long
   code
   clear(ret:val)
   self.prow=mysql_fetch_row(self.pres)
   if not self.prow; return(ret:val) .
   if records(qff)
       if self.kolfields<records(qff); return(ret:val) .
       loop i#=1 to records(qff)
           get(qff,i#)
           j#=sol(i#,self.prow,buff)
           qff.ptr = buff
           ret:val+=1
       .
   else
       if self.kolfields<records(self.qqq); return(ret:val) .
       loop i#=1 to records(self.qqq)
           get(self.qqq,i#)
           j#=sol(i#,self.prow,buff)
           self.qqq.ptr = buff
           ret:val+=1
       .
   .
   return(ret:val)

mysqlclassType.makeselect procedure()
ret:val    byte
   code
   clear(ret:val)
   self.basezapros
   if not self.zapros; return(ret:val) .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab
   self.zapros2='SELECT COUNT(*) FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' WHERE '&self.filter
       self.zapros2=self.zapros2&' WHERE '&self.filter
   .
   self.zapros=self.zapros & ' ORDER BY '
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros=self.zapros & self.qsrt.name
           else; self.zapros=self.zapros & ',' & self.qsrt.name
           .
           if self.desc; self.zapros=self.zapros & ' DESC' .
       .
   else
       self.zapros=self.zapros & self.primarykey
       if self.desc; self.zapros=self.zapros & ' DESC' .
   .
   if self.limit; self.zapros=self.zapros&' LIMIT '&self.limit;  .
   ret:val=1
   return(ret:val)

mysqlclassType.makeupdate procedure()
ret:val    byte
   code
   clear(ret:val)
   if not self.tab; return(ret:val) .
   j#=records(self.qqq);
   if not j#; return(ret:val) .
   clear(self.zapros)
   if records(qff)
       loop i#=1 to records(qff)
           get(qff,i#)
           if errorcode(); return(ret:val) .
           if qff.name=self.primarykey; cycle .
           buff1=clip(qff.ptr)
           MysqlLock.Wait()
           k#=mysql_real_escape_string(self.pmysql,buff,buff1,len(buff1))
           MysqlLock.Release();
           if not self.zapros
               self.zapros=qff.name&'='''&buff&''''
           else
               self.zapros=self.zapros&','&qff.name&'='''&buff&''''
       .   .
   else
       loop i#=1 to j#
           get(self.qqq,i#)
           if errorcode(); return(ret:val) .
           if self.qqq.name=self.primarykey; cycle .
           buff1=clip(self.qqq.ptr)
           MysqlLock.Wait()
           k#=mysql_real_escape_string(self.pmysql,buff,buff1,len(buff1))
           MysqlLock.Release();
           if not self.zapros
               self.zapros=self.qqq.name&'='''&buff&''''
           else
               self.zapros=self.zapros&','&self.qqq.name&'='''&buff&''''
       .   .
   .
   self.zapros='UPDATE ' & self.tab & ' SET ' & self.zapros
   self.zapros=self.zapros&' WHERE '&self.primarykey&'='''&clip(self.primaryptr)&''''
   ret:val=1
   return(ret:val)

mysqlclassType.makeadd procedure()
ret:val    byte
   code
   clear(ret:val)
   if not self.tab; return(ret:val) .
   j#=records(self.qqq);
   if not j#; return(ret:val) .
   clear(self.zapros)
   if records(qff)
       loop i#=1 to records(qff)
           get(qff,i#)
           if errorcode(); return(ret:val) .
           if qff:name=self.primarykey; cycle .
           buff1=clip(qff.ptr)
           MysqlLock.Wait()
           k#=mysql_real_escape_string(self.pmysql,buff,buff1,len(buff1))
           MysqlLock.Release();
           if not self.zapros
               self.zapros=qff.name&'='''&buff&''''
           else
               self.zapros=self.zapros&','&qff.name&'='''&buff&''''
       .   .
   else
       loop i#=1 to j#
           get(self.qqq,i#)
           if errorcode(); return(ret:val) .
           if self.qqq.name=self.primarykey; cycle .
           buff1=clip(self.qqq.ptr)
           MysqlLock.Wait()
           k#=mysql_real_escape_string(self.pmysql,buff,buff1,len(buff1))
           MysqlLock.Release();
           if not self.zapros
               self.zapros=self.qqq.name&'='''&buff&''''
           else
               self.zapros=self.zapros&','&self.qqq.name&'='''&buff&''''
       .   .
   .
   self.zapros='INSERT INTO ' & self.tab & ' SET ' & self.zapros
   ret:val=1
   return(ret:val)

mysqlclassType.get::qff procedure(sss)
found  byte,auto
   code
   free(qff)
   if not sss; return(0) .
   k#=1; j#=len(clip(sss))
   loop i#=1 to j#
       if sss[i#]=','
           qff:name=left(sub(sss,k#,i#-k#))
           if qff:name; add(qff) .
           k#=i#+1
   .   .
   if k#<j#
       qff:name=left(sub(sss,k#,j#-k#+1))
       if qff:name; add(qff) .
   .
   loop i#=1 to records(qff)
       get(qff,i#)
       clear(found)
       loop j#=1 to records(self.qqq)
           get(self.qqq,j#)
           if errorcode(); break .
           if qff:name=self.qqq.name; found=1; break .
       .
       if not found
           setcursor()
           message('       "'&qff:name&'"',|
           ' SQL-!',ICON:Exclamation,Button:Cancel,Button:Cancel,0)
           free(qff)
           return(0)
       .
       qff:ptr &= self.qqq.ptr
       put(qff)
   .
   return(records(qff))

mysqlclassType.getrecord procedure(fields)
ret:val    byte
   code
   clear(ret:val)
   if omitted(2) or fields='*'
       free(qff)
   else
       mys=clip(fields)
       if not self.get::qff(mys); return(ret:val) .
   .
   if not self.makegetrecord(); free(qff); return(ret:val) .
   if self.prepare(); free(qff); return(ret:val) .
   if self.fillnext(); ret:val=1 .
   self.free_rez
   return(ret:val)

mysqlclassType.delrecord procedure
ret:val    byte
   code
   clear(ret:val)
   self.zapros='DELETE FROM '&self.tab&' WHERE '&self.primarykey&'='''&clip(self.primaryptr)&''''
   if self.ping()
       return(ret:val)
   .
   MysqlLock.Wait()
   if mysql_real_query(self.pmysql, self.zapros, len(self.zapros))
       self.mess__(3)
   else
       ret:val=1
   .
   MysqlLock.Release();
   return(ret:val)

mysqlclassType.putrecord procedure(fields)
ret:val    byte
   code
   clear(ret:val)
   if omitted(2) or fields='*'
       free(qff)
   else
       mys=clip(fields)
       if not self.get::qff(mys); return(ret:val) .
   .
   if not self.makeupdate(); free(qff); return(ret:val) .
   free(qff)
   if self.ping()
       return(ret:val)
   .
   MysqlLock.Wait()
   if mysql_real_query(self.pmysql, self.zapros, len(self.zapros))
       self.mess__(3)
   else
       ret:val=1
   .
   MysqlLock.Release();
   return(ret:val)

mysqlclassType.addrecord procedure(fields)
ret:val    byte
   code
   clear(ret:val)
   if omitted(2) or fields='*'
       free(qff)
   else
       mys=clip(fields)
       if not self.get::qff(mys); return(ret:val) .
   .
   if not self.makeadd(); free(qff); return(ret:val) .
   free(qff)
   if self.ping()
       return(ret:val)
   .
   MysqlLock.Wait()
   if mysql_real_query(self.pmysql, self.zapros, len(self.zapros))
       self.mess__(3)
   else
       self.primaryptr=mysql_insert_id(self.pmysql)
       ret:val=1
   .
   MysqlLock.Release();
   return(ret:val)

mysqlclassType.srtnext procedure()
   code
   clear(ssrt)
   k1#=records(self.qsrt)
   loop k2#=k1# to 1 by -1
       loop i#=1 to k2#
           get(self.qsrt,i#)
           if i#=1
               if ssrt
                   ssrt=ssrt & ') OR ('
               else
                   ssrt='('
               .
               if i#=k2#
                   if self.desc
                       ssrt=ssrt & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''')'
                   else
                       ssrt=ssrt & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''')'
                   .
               else
                   ssrt=ssrt & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
              .
           else
               if i#=k2#
                   if self.desc
                       ssrt=ssrt & ' AND ' & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''''
                   else
                       ssrt=ssrt & ' AND ' & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''''
                   .
               else
                  ssrt=ssrt & ' AND ' & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
               .
   .   .   .

mysqlclassType.srtsame procedure()
   code
   clear(ssrt)
   k1#=records(self.qsrt)
   loop k2#=k1# to 1 by -1
       loop i#=1 to k2#
           get(self.qsrt,i#)
           if i#=1
               if ssrt
                   ssrt=ssrt & ') OR ('
               else
                   ssrt='('
               .
               if i#=k2#
                   if k2#=k1#
                       if self.desc
                           ssrt=ssrt & self.qsrt.name & '<<=''' & clip(self.qsrt.ptr)&''')'
                       else
                           ssrt=ssrt & self.qsrt.name & '>=''' & clip(self.qsrt.ptr)&''')'
                       .
                   else
                       if self.desc
                           ssrt=ssrt & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''')'
                       else
                           ssrt=ssrt & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''')'
                       .
                   .
               else
                   ssrt=ssrt & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
              .
           else
               if i#=k2#
                   if k2#=k1#
                       if self.desc
                           ssrt=ssrt & ' AND ' & self.qsrt.name & '<<=''' & clip(self.qsrt.ptr)&''''
                       else
                           ssrt=ssrt & ' AND ' & self.qsrt.name & '>=''' & clip(self.qsrt.ptr)&''''
                       .
                   else
                       if self.desc
                           ssrt=ssrt & ' AND ' & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''''
                       else
                           ssrt=ssrt & ' AND ' & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''''
                       .
                   .
               else
                  ssrt=ssrt & ' AND ' & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
               .
   .   .   .

mysqlclassType.srtprev procedure()
   code
   clear(ssrt)
   k1#=records(self.qsrt)
   loop k2#=k1# to 1 by -1
       loop i#=1 to k2#
           get(self.qsrt,i#)
           if i#=1
               if ssrt
                   ssrt=ssrt & ') OR ('
               else
                   ssrt='('
               .
               if i#=k2#
                   if self.desc
                       ssrt=ssrt & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''')'
                   else
                       ssrt=ssrt & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''')'
                   .
               else
                   ssrt=ssrt & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
              .
           else
               if i#=k2#
                   if self.desc
                       ssrt=ssrt & ' AND ' & self.qsrt.name & '>''' & clip(self.qsrt.ptr)&''''
                   else
                       ssrt=ssrt & ' AND ' & self.qsrt.name & '<<''' & clip(self.qsrt.ptr)&''''
                   .
               else
                  ssrt=ssrt & ' AND ' & self.qsrt.name & '=''' & clip(self.qsrt.ptr)&''''
               .
   .   .   .

mysqlclassType.makenext procedure(count)
   code
   free(qff)
   self.basezapros
   if not self.zapros; return .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab&' WHERE '
   if records(self.qsrt)
       self.srtnext
       self.zapros=self.zapros & ssrt
   else
       if self.desc
           self.zapros=self.zapros & self.primarykey & '<'''& clip(self.primaryptr)&''''
       else
           self.zapros=self.zapros & self.primarykey & '>'''& clip(self.primaryptr)&''''
       .
   .

   self.zapros2='SELECT COUNT(*) FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' AND ('&self.filter&')'
       self.zapros2=self.zapros2&' WHERE '&self.filter
   .
   self.zapros=self.zapros & ' ORDER BY '
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros=self.zapros & self.qsrt.name
           else; self.zapros=self.zapros & ',' & self.qsrt.name
           .
           if self.desc; self.zapros=self.zapros & ' DESC' .
       .
   else
       self.zapros=self.zapros & self.primarykey
       if self.desc; self.zapros=self.zapros & ' DESC' .
   .
   if omitted(2)
       self.zapros=self.zapros&' LIMIT 1'
   else
       self.zapros=self.zapros&' LIMIT '&count
   .
   return

mysqlclassType.makesame procedure(count)
   code
   free(qff)
   self.basezapros
   if not self.zapros; return .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab&' WHERE '
   if records(self.qsrt)
       self.srtsame
       self.zapros=self.zapros & ssrt
   else
       if self.desc;
           self.zapros=self.zapros & self.primarykey & '<='''& clip(self.primaryptr) &''''
       else
           self.zapros=self.zapros & self.primarykey & '>='''& clip(self.primaryptr) &''''
       .
   .

   self.zapros2='SELECT COUNT(*) FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' AND ('&self.filter&')'
       self.zapros2=self.zapros2&' WHERE '&self.filter
   .
   self.zapros=self.zapros & ' ORDER BY '
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros=self.zapros & self.qsrt.name
           else; self.zapros=self.zapros & ',' & self.qsrt.name
           .
           if self.desc; self.zapros=self.zapros & ' DESC' .
       .
   else
       self.zapros=self.zapros & self.primarykey
       if self.desc; self.zapros=self.zapros & ' DESC' .
   .
   if omitted(2)
       self.zapros=self.zapros&' LIMIT 1'
   else
       self.zapros=self.zapros&' LIMIT '&count
   .
   return

mysqlclassType.makegetrecord procedure()
ret:val    byte
   code
   clear(ret:val)
   self.basezapros
   if not self.zapros; return(ret:val) .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab
   self.zapros=self.zapros&' WHERE '&self.primarykey&'='''&clip(self.primaryptr)&''''
   ret:val=1
   return(ret:val)

mysqlclassType.firstpage procedure(limit,kol_all)
   code
   if omitted(2); clear(self.limit); else; self.limit=limit .
   if not self.makeselect(); return(1) .
   if self.prepare(); return(2) .
   if not omitted(3); kol_all=self.kol_all .
   return(0)

mysqlclassType.basezapros procedure
   code
   clear(self.zapros)
   if not self.tab; return .
   j#=records(self.qqq);
   if not j#; return .
   if records(qff)
       loop i#=1 to records(qff)
           get(qff,i#)
           if errorcode(); clear(self.zapros); return .
           if not self.zapros
               self.zapros=qff.name
           else
               self.zapros=self.zapros&','&qff.name
       .   .
   else
       loop i#=1 to j#
           get(self.qqq,i#)
           if errorcode(); clear(self.zapros); return .
           if not self.zapros
               self.zapros=self.qqq.name
           else
               self.zapros=self.zapros&','&self.qqq.name
       .   .
   .

mysqlclassType.next procedure(count,kol_all)
   code
   if omitted(2)
       self.makenext()
   else
       self.makenext(count)
   .
   if self.prepare(); return(2) .
   if not omitted(3); kol_all=self.kol_all .
   return(0)

mysqlclassType.same procedure(count,kol_all)
   code
   if omitted(2)
       self.makesame()
   else
       self.makesame(count)
   .
   if self.prepare(); return(2) .
   if not omitted(3); kol_all=self.kol_all .
   return(0)

mysqlclassType.lastpage  procedure(count,kol_all)
   code
   if omitted(2)
       if not self.makelast(); return(1) .
   else
       if not self.makelast(count); return(1) .
   .
   if self.prepare(); return(2) .
   if not omitted(3); kol_all=self.kol_all .
   return(0)

mysqlclassType.makelast procedure(count)
ret:val    byte
   code
   clear(ret:val)
   self.basezapros
   if not self.zapros; return(ret:val) .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab
   self.zapros2='SELECT COUNT(*) FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' WHERE '&self.filter
       self.zapros2=self.zapros2&' WHERE '&self.filter
   .
   self.zapros=self.zapros & ' ORDER BY '
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros=self.zapros & self.qsrt.name
           else; self.zapros=self.zapros & ',' & self.qsrt.name
           .
           if ~self.desc; self.zapros=self.zapros & ' DESC' .
       .
   else
       self.zapros=self.zapros & self.primarykey
       if ~self.desc; self.zapros=self.zapros & ' DESC' .
   .
   if omitted(2)
       self.zapros=self.zapros&' LIMIT 1'
   else
       self.zapros=self.zapros&' LIMIT '&count
   .
   ret:val=1
   return(ret:val)

mysqlclassType.makeprev procedure(count)
   code
   free(qff)
   self.basezapros
   if not self.zapros; return .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab&' WHERE '
   if records(self.qsrt)
       self.srtprev
       self.zapros=self.zapros & ssrt
   else
       if self.desc;
           self.zapros=self.zapros & self.primarykey & '>'''& clip(self.primaryptr)&''''
       else
           self.zapros=self.zapros & self.primarykey & '<<'''& clip(self.primaryptr)&''''
       .
   .

   self.zapros2='SELECT COUNT(*) FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' AND ('&self.filter&')'
       self.zapros2=self.zapros2&' WHERE '&self.filter
   .
   self.zapros=self.zapros & ' ORDER BY '
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros=self.zapros & self.qsrt.name
           else; self.zapros=self.zapros & ',' & self.qsrt.name
           .
           if ~self.desc; self.zapros=self.zapros & ' DESC' .
       .
   else
       self.zapros=self.zapros & self.primarykey
       if ~self.desc; self.zapros=self.zapros & ' DESC' .
   .
   if omitted(2)
       self.zapros=self.zapros&' LIMIT 1'
   else
       self.zapros=self.zapros&' LIMIT '&count
   .
   return

mysqlclassType.prev procedure(count,kol_all)
   code
   if omitted(2)
       self.makeprev()
   else
       self.makeprev(count)
   .
   if self.prepare(); return(2) .
   if not omitted(3); kol_all=self.kol_all .
   return(0)

mysqlclassType.minmax procedure(min_var,max_var)
   code
   clear(self.zapros)
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros='MIN(' & self.qsrt.name & '),MAX(' & self.qsrt.name & ')'
           else; self.zapros=self.zapros & ',MIN(' & self.qsrt.name & '),MAX(' & self.qsrt.name & ')'
       .   .
   else
       self.zapros='MIN(' & self.primarykey & '),MAX(' & self.primarykey& ')'
   .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' WHERE ('&self.filter&')'
   .
   if self.prepare(); return .
   self.prow=mysql_fetch_row(self.pres)
   j#=sol(1,self.prow,buff)
   min_var=buff
   j#=sol(2,self.prow,buff)
   max_var=buff
   self.free_rez
   return

mysqlclassType.minmaxtime procedure(min_var,max_var)
   code
   clear(self.zapros)
   if records(self.qsrt)
       loop i#=1 to records(self.qsrt)
           get(self.qsrt,i#)
           if i#=1; self.zapros='unix_timestamp(MIN(' & self.qsrt.name & ')),unix_timestamp(MAX(' & self.qsrt.name & '))'
           else; self.zapros=self.zapros & ',unix_timestamp(MIN(' & self.qsrt.name & ')),unix_timestamp(MAX(' & self.qsrt.name & '))'
       .   .
   else
       self.zapros='unix_timestamp(MIN(' & self.primarykey & ')),unix_timestamp(MAX(' & self.primarykey& '))'
   .
   self.zapros='SELECT '&self.zapros&' FROM '&self.tab
   if self.filter
       self.zapros=self.zapros&' WHERE ('&self.filter&')'
   .
   if self.prepare(); return .
   self.prow=mysql_fetch_row(self.pres)
   j#=sol(1,self.prow,buff)
   min_var=buff
   j#=sol(2,self.prow,buff)
   max_var=buff
   self.free_rez
   return

mysqlclassType.send procedure(zapros,vozvr,rezult)
   code
   if self.ping()
       return(1)
   .
   MysqlLock.Wait()
   if omitted(2)
       kk#=mysql_real_query(self.pmysql,self.zapros,len(self.zapros))
   else
       kk#=mysql_real_query(self.pmysql,zapros,len(zapros))
   .
   if omitted(3)
       if kk#; self.mess__(3); MysqlLock.Release(); return(1) .
   .
   if omitted(4)
       self.kolrec=mysql_affected_rows(self.pmysql)
   else
       self.pres=mysql_store_result(self.pmysql)
       if not self.pres; self.mess__(4); MysqlLock.Release(); return(4) .
       self.prow=mysql_fetch_row(self.pres)
       if self.prow
           j#=sol(1,self.prow,buff)
           rezult=buff
       else
           rezult='';
       .
       mysql_free_result(self.pres)
       clear(self.pres)
   .
   MysqlLock.Release();
   return(0)

mysqlclassType.options procedure(byte option,*? arg)
parg   any
   code
   parg &= arg
   MysqlLock.Wait()
   i#=mysql_options(self.pmysql,option,parg)
   MysqlLock.Release();
   return(i#)

mysqlclassType.idnumproc procedure
   code
   MysqlLock.Wait()
   self.ccc=mysql_info(self.pmysql)
   MysqlLock.Release()

mysqlclassType.fillpole procedure(kol,pole1,pole2,pole3,pole4,pole5)
ret:val    long
   code
   clear(ret:val)
   self.prow=mysql_fetch_row(self.pres)
   if not self.prow; return(ret:val) .
   loop i#=1 to kol
       get(qff,i#)
       j#=sol(i#,self.prow,buff)
       execute i#
           pole1 = buff
           pole2 = buff
           pole3 = buff
           pole4 = buff
           pole5 = buff
       .
       ret:val+=1
   .
   return(ret:val)

mysqlclassType.ping procedure()
   code
   MysqlLock.Wait()
   loop 3 times
       if mysql_ping(self.pmysql)=0; MysqlLock.Release(); return(0) .
   .
   MysqlLock.Release()
   setcursor()
   message('   !| ',|
   ' !',ICON:Exclamation,Button:Cancel,Button:Cancel,0)
   return(1)
